local KnifeGrinder = ...

-- Register prefab nodes (currently only one core model)
KnifeGrinder:registerAssetId("models/knifegrinder.fbx/Prefab/knifegrinderPart", "KNIFEGRINDER_WORKPLACE_PREFAB")

KnifeGrinder:register({
--Dclare que l'objet que l'on cre appartient  la class BUILDING
	DataType = "BUILDING",
--Dclare la classe de l'objet que l'on cre
	Id = "KNIFEGRINDER_WORKPLACE",
	Name = "KNIFEGRINDER_WORKPLACE_NAME",
	Description = "KNIFEGRINDER_WORKPLACE_DESC",
--Renseigne le champ Building Type. cela va permettre de classer l'objet dans les menus
	BuildingType = "GENERAL",
--renseigne le champ BuildingPartList de l'objet que l'on cre un peu plus loin	
	BuildingPartSetList = {
		{
			Name = "KNIFEGRINDER_WORKPLACE_PARTSETLIST_NAME",
	                BuildingPartList = { "KNIFEGRINDER_WORKPLACE_PART" }
                }
        }
--Renseigne le champ Nombre de villageois requis pour la construction. Ici inactiv pour le test
	--VillagerRequired = { Status = "NEWCOMER", Quantity = 9 }
})


-- Register the shoemaker workplace part
KnifeGrinder:register({
	DataType = "BUILDING_PART",
	Id = "KNIFEGRINDER_WORKPLACE_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "KNIFEGRINDER_WORKPLACE_PREFAB"
	},
--Ca c'est pour dclarer le visuel de construction si il y en a un !
	ConstructionVisual = "KNIFEGRINDER_WORKPLACE_PREFAB",
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 1 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 },
			{ Resource = "TOOL", Quantity = 1 },
			{ Resource = "POLISHED_STONE", Quantity = 1 }
		}
	},
	AssetBuildingFunction = "KNIFEGRINDER_FUNCTION"
})
KnifeGrinder:register({
		DataType = "BUILDING_FUNCTION_MARKET",
                Id = "KNIFEGRINDER_FUNCTION",
                TypeList = { "GOODS" },
                IsOverrideCapacity = true,
                CapacityPerSlot = 50,
		WorkerCapacity = 1,
                RelatedJob = { Job = "KNIFEGRINDER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "TOOL", Quantity = 50 }
                },
                ResourceListNeeded = {
                	{ Resource = "TOOL", Quantity = 1 }
                },
                ResourceProduced = {
			{ Resource = "KNIFE", Quantity = 1 }
                }
})

KnifeGrinder:registerPrefabComponent("models/knifegrinder.fbx/Prefab/knifegrinderPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {5, 3}
})

-- Register grounding components

KnifeGrinder:registerPrefabComponent("models/knifegrinder.fbx/Prefab/knifegrinderPart/step_2_B", {
	DataType = "COMP_GROUNDED"
})
KnifeGrinder:registerPrefabComponent("models/knifegrinder.fbx/Prefab/knifegrinderPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 5, 3 }
})

KnifeGrinder:registerAssetId("models/knifegrinder.fbx/Prefab/knifegrinderPart/step_2_B/meule/SmokeEmitter", "KNIFEGRINDER_SMOKE_EMITTER_PREFAB")

KnifeGrinder:registerPrefabComponent("models/knifegrinder.fbx/Prefab/knifegrinderPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{ "KNIFEGRINDER_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

-- Register particle system

KnifeGrinder:registerPrefabComponent("models/knifegrinder.fbx/Prefab/knifegrinderPart/step_2_B/meule/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_BLACKSMITH_GRIND",
	IsPlaying = true,
	IsEmitting = false
})

KnifeGrinder:registerPrefabComponent("models/knifegrinder.fbx/Prefab/knifegrinderPart/step_2_B/meule/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

